#ifndef CASE_H
#include "Case.h"
#endif

#ifndef CASE_VIEW_H
#include "CaseView.h"
#endif


cView::cView(BRect rect, char *name,BWindow *theWindow)
	   	   : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW)
{
#pragma unused(theWindow)
	curV=-1;
}



void cView::AttachedToWindow()
{
	BRect bFrame;

	bFrame= Frame();
	bFrame.OffsetTo(B_ORIGIN);
	bFrame.right-=15;

	fItName = new CListView(this,bFrame,"Item list",B_FOLLOW_ALL,B_WILL_DRAW);
	if(fItName) {
		fAppScrollView = new BScrollView("app scroll",fItName,B_FOLLOW_ALL,0,FALSE,TRUE,TRUE);
		
		if(fAppScrollView)
			AddChild(fAppScrollView);
		
	}
	UpdateItList();
}




void cView::UpdateItList(void)
{
#pragma warn_possunwant off
		cItem *theItem;
		while(theItem=(cItem*)fItName->FirstItem())
		{	fItName->RemoveItem(theItem);
			delete theItem->itemDir;
			delete theItem;	
		}
#pragma warn_possunwant reset
        BVolume bootVol=boot_volume();
		BDirectory *root_dir=new BDirectory;
		bootVol.GetRootDirectory(root_dir);
		AddSubDir(root_dir);
		RemoveSubDir(fItName->CountItems()-1,0);// le dernier dossier est la poubelle
}

void cView::AddSubDir(BDirectory *cDir,long cLev, long curItem,bool cSel)
{
    long counter; 	
	for(counter=0;counter<cDir->CountDirectories();counter++)
	{	cItem *temp=new cItem;
		if(temp) {
			temp->itemDir=new BDirectory;
			cDir->GetDirectory(counter,temp->itemDir);
			temp->open=false;
			temp->level=cLev;
			temp->selected=cSel;
			fItName->AddItem(temp,curItem);
		}
	}
}

void cView::RemoveSubDir(long curItem,long curLev)
{
	bool done=false;
	do 
	{	cItem *line=(cItem*)fItName->ItemAt(curItem);
		if(line && line->level>=curLev)
		{	fItName->RemoveItem(curItem);
			delete line->itemDir;
			delete line;
		} else done=true;
	} while(!done);
}
			
void cView::Triangle(long curV)
{			
	cItem *line=(cItem*)fItName->ItemAt(curV);
	line->open=(!line->open);
	if(line->open)
		AddSubDir(line->itemDir,line->level+1,curV+1,line->selected);
	else
		RemoveSubDir(curV+1,line->level+1);
	fItName->Invalidate();
}

void cView::Mark(long curV)
{
	bool done;
	cItem *line=(cItem*)fItName->ItemAt(curV);
	line=(cItem*)fItName->ItemAt(curV);
	long curLev=line->level;
	line->selected=(!line->selected);
	fItName->InvalidateItem(curV);
	if(line->selected)
	// valider tous les dossiers aval ouverts
	{	done=false;
		do 
		{	line=(cItem*)fItName->ItemAt(++curV);
			if(line && line->level>curLev)
			{	line->selected=TRUE;
				fItName->InvalidateItem(curV);
			} else done=TRUE;
		} while(!done);
	} else if(curLev!=0)
	//deselecter les dossiers amont
	{	done=false;
		do
		{	line=(cItem*)fItName->ItemAt(--curV);
			if(line) 
			{	char name[B_FILE_NAME_LENGTH];
				line->itemDir->GetName(name);
				printf("%s %d %d\n",name,line->level,curLev);
				if(line->level==curLev-1)
				{	if(line->selected)
					{	line->selected=false;
						fItName->InvalidateItem(curV);
						curLev--;// pour ne pas desactiver les "cousins"
						if(line->level==0) done=TRUE;
					} else done=TRUE;
				} 
			} else done=TRUE;
		} while(!done);
	}
}
#pragma mark --CListView

CListView::CListView(cView *mother,BRect frame,const char *name, ulong resizingMode,ulong flags)
			:BListView(frame, name, resizingMode, flags)
{
	mView=mother;
}

void CListView::DrawItem(BRect updateRect, long index)
{
#pragma unused(updateRect)
	SetFontName("Emily");
	BRect fFrame=ItemFrame(index);
	cItem *line=(cItem*)ItemAt(index);
	MovePenTo(10+16*line->level,fFrame.top+1);
	DrawTriangle(line->open);
	MovePenTo(35+16*line->level,fFrame.bottom-BaselineOffset());
	char name[B_FILE_NAME_LENGTH];
	line->itemDir->GetName(name);
	DrawString(name);
	if(line->selected)
	{	MovePenTo(200,fFrame.bottom-16.0);
		DrawRes('MICN',"MARK");
	}
}

void CListView::DrawTriangle(bool open)
{
	DrawRes('MICN', open?"OPEN":"CLOS");
}

void CListView::HighlightItem(bool flag, long index)
{
#pragma unused(flag,index)
}

void CListView::MouseDown(BPoint point)
{	
	long curV=point.y/ItemHeight();	
	cItem *line=(cItem*)ItemAt(curV);
	if(point.x<35+16*line->level)
		mView->Triangle(curV);
	else
		mView->Mark(curV);
	//inherited::MouseDown(point);
}

float CListView::ItemHeight(void)
{
	return 16.0;
}

void CListView::DrawRes(ulong id,char* name)
{
	app_info info;
	long length,err;
	void *rawIcon;
	float size;
	size=(id=='ICON')?31.0:15.0;
	if ((err=be_app->GetAppInfo(&info))!=B_NO_ERROR)
	{	printf("GetAppInfo");
		return;
	}
	BResourceFile appFile(info.ref);
	if ((err=appFile.Open(B_READ_ONLY))!=B_NO_ERROR)
	{	printf("Open");
		return;
	}
	if ((rawIcon=appFile.FindResource(id,name,&length))==NULL)
		{	printf("FindResource %s\n",name);
			return;
		} else {
			BRect rect(0.0,0.0,size,size);
			BBitmap *image=new BBitmap(rect,B_COLOR_8_BIT);
			image->SetBits(rawIcon,length,0,B_COLOR_8_BIT);
			DrawBitmap(image);
		}
}


//void CListView::DrawTriangle(bool open)
//{
//	rgb_color oHigh,oLow;
//	BPoint cPen=PenLocation();
//	oHigh=HighColor();
//	oLow=LowColor();
//	BPolygon *tPoints=new BPolygon;
//	SetHighColor(gray47);
//	if(open) {
//		FillTriangle(BPoint(cPen.x,cPen.y+3),BPoint(cPen.x+10,cPen.y+3),BPoint(cPen.x+5,cPen.y+8));
//		SetHighColor(black);
//		StrokeLine(BPoint(cPen.x+10,cPen.y+3),BPoint(cPen.x+5,cPen.y+8));
//	} else {
//		FillTriangle(BPoint(cPen.x,cPen.y),BPoint(cPen.x,cPen.y+10),BPoint(cPen.x+5,cPen.y+5));
//		SetHighColor(black);
//		StrokeLine(BPoint(cPen.x,cPen.y+10),BPoint(cPen.x+5,cPen.y+5));
//	}
//	SetHighColor(oHigh);
//}
